// Auto-generated. Do not edit!

// (in-package capabilities.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Capability = require('./Capability.js');

//-----------------------------------------------------------

class RunningCapability {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.capability = null;
      this.dependent_capabilities = null;
      this.started_by = null;
      this.pid = null;
    }
    else {
      if (initObj.hasOwnProperty('capability')) {
        this.capability = initObj.capability
      }
      else {
        this.capability = new Capability();
      }
      if (initObj.hasOwnProperty('dependent_capabilities')) {
        this.dependent_capabilities = initObj.dependent_capabilities
      }
      else {
        this.dependent_capabilities = [];
      }
      if (initObj.hasOwnProperty('started_by')) {
        this.started_by = initObj.started_by
      }
      else {
        this.started_by = '';
      }
      if (initObj.hasOwnProperty('pid')) {
        this.pid = initObj.pid
      }
      else {
        this.pid = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type RunningCapability
    // Serialize message field [capability]
    bufferOffset = Capability.serialize(obj.capability, buffer, bufferOffset);
    // Serialize message field [dependent_capabilities]
    // Serialize the length for message field [dependent_capabilities]
    bufferOffset = _serializer.uint32(obj.dependent_capabilities.length, buffer, bufferOffset);
    obj.dependent_capabilities.forEach((val) => {
      bufferOffset = Capability.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [started_by]
    bufferOffset = _serializer.string(obj.started_by, buffer, bufferOffset);
    // Serialize message field [pid]
    bufferOffset = _serializer.int32(obj.pid, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type RunningCapability
    let len;
    let data = new RunningCapability(null);
    // Deserialize message field [capability]
    data.capability = Capability.deserialize(buffer, bufferOffset);
    // Deserialize message field [dependent_capabilities]
    // Deserialize array length for message field [dependent_capabilities]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.dependent_capabilities = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.dependent_capabilities[i] = Capability.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [started_by]
    data.started_by = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [pid]
    data.pid = _deserializer.int32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Capability.getMessageSize(object.capability);
    object.dependent_capabilities.forEach((val) => {
      length += Capability.getMessageSize(val);
    });
    length += _getByteLength(object.started_by);
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'capabilities/RunningCapability';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f97e2b23f907893008679ba2ff64fafc';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Name and provider of this running capability
    Capability capability
    # Capabilities which depend on this one
    Capability[] dependent_capabilities
    # Message stating what started this capability
    string started_by
    # Process ID of the running provider
    int32 pid
    
    ================================================================================
    MSG: capabilities/Capability
    # Capability
    string capability
    # Used provider
    string provider
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new RunningCapability(null);
    if (msg.capability !== undefined) {
      resolved.capability = Capability.Resolve(msg.capability)
    }
    else {
      resolved.capability = new Capability()
    }

    if (msg.dependent_capabilities !== undefined) {
      resolved.dependent_capabilities = new Array(msg.dependent_capabilities.length);
      for (let i = 0; i < resolved.dependent_capabilities.length; ++i) {
        resolved.dependent_capabilities[i] = Capability.Resolve(msg.dependent_capabilities[i]);
      }
    }
    else {
      resolved.dependent_capabilities = []
    }

    if (msg.started_by !== undefined) {
      resolved.started_by = msg.started_by;
    }
    else {
      resolved.started_by = ''
    }

    if (msg.pid !== undefined) {
      resolved.pid = msg.pid;
    }
    else {
      resolved.pid = 0
    }

    return resolved;
    }
};

module.exports = RunningCapability;
